Type TextStruct
    Text As String
    FontName As String
    Size As Integer
    Colour As Integer
    Style As Integer
    Alignment As Integer
End Type

Global Const STYLE_BOLD = 1
Global Const STYLE_ITALIC = 2
Global Const STYLE_UNDERLINE = 4

Global Const ALIGN_CENTRE = 1
Global Const ALIGN_RIGHT = 2
Global Const ALIGN_LEFT = 3
Global Const ALIGN_JUSTIFIED = 4

Global Const DEFAULT = "DEFAULT"

Sub AddText (ArrayName() As TextStruct, Text, FontName, Size, Colour, Style, Alignment)
    ReDim Preserve ArrayName(UBound(ArrayName) + 1)
    ArrayName(UBound(ArrayName)).Text = Text
    ArrayName(UBound(ArrayName)).FontName = FontName
    ArrayName(UBound(ArrayName)).Size = Size
    ArrayName(UBound(ArrayName)).Colour = Colour
    ArrayName(UBound(ArrayName)).Style = Style
    ArrayName(UBound(ArrayName)).Alignment = Alignment
End Sub

Function DisplayText (ControlName As PictureBox, Text, FontName, Size, Colour, Style, Alignment, Y) As Integer
    lines = 1
    ControlName.ScaleMode = 3
    ControlName.CurrentY = Y
    ControlName.FontBold = False
    ControlName.FontItalic = False
    ControlName.FontUnderline = False
    ControlName.FontSize = Size
    ControlName.ForeColor = QBColor(Colour)
    If FontName <> DEFAULT Then
        ControlName.FontName = FontName
    End If
    If (Style And STYLE_BOLD) = STYLE_BOLD Then
        ControlName.FontBold = True
    End If
    If (Style And STYLE_ITALIC) = STYLE_ITALIC Then
        ControlName.FontItalic = True
    End If
    If (Style And STYLE_UNDERLINE) = STYLE_UNDERLINE Then
        ControlName.FontUnderline = True
    End If
    If ControlName.TextWidth(Text) > ControlName.ScaleWidth Then
        bst = 0
        ast = InStr(bst + 1, Text, " ")
        Do Until ast = 0
            nw = Mid$(Text, bst + 1, ast - bst - 1)
            If ControlName.TextWidth(Phrase & " " & nw) > ControlName.ScaleWidth Then
                ControlName.Print Trim$(Phrase)
                Select Case Alignment
                Case ALIGN_CENTRE
                    ControlName.CurrentX = (ControlName.ScaleWidth / 2) - (ControlName.TextWidth(Trim(Text)) / 2)
                Case ALIGN_LEFT
                    ControlName.CurrentX = 0
                Case ALIGN_RIGHT
                    ControlName.CurrentX = ControlName.ScaleWidth - ControlName.TextWidth(Text)
                End Select
                Phrase = nw
                lines = lines + 1
            Else
                Phrase = Phrase & " " & nw
            End If
            bst = ast
            ast = InStr(bst + 1, Text, " ")
        Loop
        If Len(Phrase) > 0 Then
            ControlName.Print Phrase
        End If
    Else
        Select Case Alignment
        Case ALIGN_CENTRE
            ControlName.CurrentX = (ControlName.ScaleWidth / 2) - (ControlName.TextWidth(Trim(Text)) / 2)
        Case ALIGN_LEFT
            ControlName.CurrentX = 0
        Case ALIGN_RIGHT
            ControlName.CurrentX = ControlName.ScaleWidth - ControlName.TextWidth(Text)
        End Select
        ControlName.Print Text
    End If
    DisplayText = (lines * ControlName.TextHeight(Text)) + 3
End Function

